<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Document</title>
  </head>

  <body>
    <script>
      // Person (firstName, lastName)
      // - can make coffee
      // - can come to workspace
      // - can use wifi

      // Student (id, group)
      // - can attend lessons
      //
      // Teacher -> Trainer, Mentor
      // - get student results

      // Trainer
      // - teach students

      // Mentor
      // - estimate homework

      // Создадим объект Person с нужными свойствами
      function Person(firstName, lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
      }

      c

      Person.prototype = {
        makeCoffee: function () {
          console.log(`${this.firstName} ${this.lastName} is making coffee`);
        },
      };

      function Student(firstName, lastName, id, group) {
        Person.call(this, firstName, lastName);
        this.group = group;
        this.id = id;
      }

      // Говорим что прототипом студента будет новый объект
      // // у которого будет прототипом Person

      Student.prototype = Object.create(Person.prototype);

      // // console.log(new Student());

      function Teacher(firstName, lastName, level) {
        Person.call(this, firstName, lastName);
        this.level = level;
        this.makeCoffee = function() {

        }
      }

      // Говорим что прототипом студента будет новый объект
      // у которого будет прототипом Person
      Teacher.prototype = Object.create(Person.prototype);

      const Stas = new Student("Stas", "Lashkov", 544, "fe3");
      const Liza = new Student("Liza", "www", 22, "fe3");
      console.log(Stas);
      console.log(Liza);
      // Stas.makeCoffee();

      const Irina = new Teacher("Irina", "Stoe", "fe3");
      // console.log(Irina);
      // Irina.makeCoffee();

      Array.prototype.duplicate = function(array) {
        console.log('ha ha')
      };
  const arra = ['1', 2, '1', 2];

  arra.duplicate(arra);
  console.log(arra)

    </script>
  </body>
</html>
